"""Fichier de configuration des datasets (principalement pour l'application)
    """

from .constants import (
    AGE_BEN_SNDS,
    BEN_CMU_TOP,
    BEN_SEX_COD,
    DIR2RAW_OPENBIO,
    DIR2RAW_OPENDAMIR,
    DIR2RAW_OPENLPP,
    DIR2RAW_OPENMEDIC,
    DIR2RAW_TEST_DS,
    PRS_NAT,
    PSE_ACT_CAT,
    PSE_ACT_SNDS,
    PSP_ACT_CAT,
    PSP_ACT_SNDS,
    SOI_ANN,
    SOI_MOI,
    YEAR,
    NB_CONSOMMANTS,
    NB_ACTES,
    NB_PATIENTS,
    DNB,
    REM,
)

SUPPORTED_DBS = {
    "openmedic": {
        "libelle": "Open Medic",
        "directory": DIR2RAW_OPENMEDIC,
        "frequency": ("year", "(\d\d\d\d)"),
        "url_schema": "https://gitlab.com/healthdatahub/schema-snds/-/raw/master/schemas/OPENMEDIC/OPEN_MEDIC.json",
        "filter_cols": [
            "SEXE",
            "BEN_REG",
            "AGE",
            "PSP_SPE",
            "CIP13",
            "ATC1",
            "ATC2",
            "ATC3",
            "ATC4",
            "ATC5",
            YEAR,
        ],
        "group_cols": [
            "SEXE",
            "BEN_REG",
            "AGE",
            "PSP_SPE",
            "CIP13",
            "ATC1",
            "ATC2",
            "ATC3",
            "ATC4",
            "ATC5",
            YEAR,
        ],
        "level_choices": ["ATC1", "ATC2", "ATC3", "ATC4", "ATC5", "CIP13"],
        "consommants": True,
        "focused_dimensions": {
            "sex": "SEXE",
            "age": "AGE",
            "region": "BEN_REG",
            "spe_presc": "PSP_SPE",
        },
        DNB: "BOITES",
        NB_CONSOMMANTS: "NBC",
        REM: "REM",
    },
    "openbio": {
        "libelle": "Open Bio",
        "directory": DIR2RAW_OPENBIO,
        "frequency": ("year", "(\d\d\d\d)"),
        "url_schema": "https://gitlab.com/healthdatahub/schema-snds/-/raw/master/schemas/OPENBIO/OPEN_BIO.json",
        "filter_cols": ["SEXE", "BEN_REG", "AGE", "PSP_SPE", "GRP", "ACTE", YEAR],
        "group_cols": ["SEXE", "BEN_REG", "AGE", "PSP_SPE", "GRP", "ACTE", YEAR],
        "level_choices": ["GRP", "ACTE"],
        "consommants": True,
        "focused_dimensions": {
            "sex": "SEXE",
            "age": "AGE",
            "region": "BEN_REG",
            "spe_presc": "PSP_SPE",
        },
        DNB: "DNB",
        NB_CONSOMMANTS: "NBC",
        REM: "REM",
    },
}

UNSUPPORTED_DBS = {
    "openlpp": {
        "libelle": "Open LPP",
        "directory": DIR2RAW_OPENLPP,
        "frequency": ("year", "(\d\d\d\d)"),
        "url_schema": "https://gitlab.com/healthdatahub/schema-snds/-/raw/master/schemas/OPENLPP/OPEN_LPP.json",
        "filter_cols": [
            "SEXE",
            "BEN_REG",
            "AGE",
            "sc1",
            "sc2",
            "CODE_LPP",
            "PSP_SPE",
            "TITRE",
            YEAR,
        ],
        "group_cols": [
            "SEXE",
            "BEN_REG",
            "AGE",
            "PSP_SPE",
            "TITRE",
            "sc1",
            "sc2",
            "CODE_LPP",
            YEAR,
        ],
        "level_choices": ["TITRE", "sc1", "sc2", "CODE_LPP"],
        "consommants": True,
        "focused_dimensions": {
            "sex": "SEXE",
            "age": "AGE",
            "region": "BEN_REG",
            "spe_presc": "PSP_SPE",
        },
        DNB: "QTE",
        NB_CONSOMMANTS: "NBC",
        REM: "REM",
    },
    "opendamir": {
        "directory": DIR2RAW_OPENDAMIR,
        "frequency": ("year_month", "(\d\d\d\d\d\d$)"),
        "url_schema": "https://gitlab.com/healthdatahub/schema-snds/-/raw/master/schemas/DAMIR/OPEN_DAMIR.json",
        "nomenclatures_dir_path": "nomenclatures/OPENDAMIR",
        "group_cols": [
            PRS_NAT,
            AGE_BEN_SNDS,
            BEN_SEX_COD,
            BEN_CMU_TOP,
            SOI_ANN,
            SOI_MOI,
        ],
        "filter_cols": [
            PRS_NAT,
            PSE_ACT_CAT,
            BEN_CMU_TOP,
            PSP_ACT_CAT,
            PSP_ACT_SNDS,
            PSE_ACT_SNDS,
            AGE_BEN_SNDS,
            SOI_ANN,
            SOI_MOI,
            BEN_SEX_COD,
        ],
        "level_choices": [PRS_NAT],
        "consommants": False,
        "focused_dimensions": {
            "sex": "BEN_SEX_COD",
            "age": "AGE_BEN_SNDS",
            "region": "BEN_RES_REG",
        },
        NB_ACTES: "PRS_ACT_NBR",
        NB_PATIENTS: "",
        REM: "",
    },
}
